#!../../../src/tops
"%22.12e" mformatset
"easy_io.v" source

define: eig_check ( Kg M --- error ) # {{{1
    is M
    is Kg
    time
    Kg M -1.0e6 10 speig_near_shift 
    time 4 pick - " %.3f seconds to compute 10 modes " format . nl
    drop ( Evec Eval )
    is eVec
    is eVal
    drop (remove time)
    "sparse eigenvalues = " . nl eVal .m nl
    "max eigenvalue error: " . nl
    Kg eVec * M eVec * eVal diagpost - abs maxfetch
    # normalize the error by dividing by the eigenvalue corresponding to error
    lop eVal swap pry
    / .  nl
    ; # 1}}}

time
  # "../triangle/onetri.db" 
  # "../triangle/three.db" 
  # "../triangle/super7.db" 
  # "quarter_hemi.db" 
  # "tilted_plate_0-18.db" 
  # "tilted_plate_20-18.db" 
  # "tilted_plate_90-18.db" 
  # "tilted_plate_90-1240.db" 
  # "../triangle/cyl.db" 
  # "../triangle/x38y10.db" 
  # "../triangle/x1y1.db" 
  # "../triangle/x1y1_90.db" 
  # "../triangle/square.db" 
  # "../triangle/two_square.db" 
  # "../triangle/x2y2.db" 
  # "../triangle/x1y10.db" 
  # "../triangle/x10y10.db" 
  # "../triangle/x50y50.db" 
  # "../triangle/x70y70.db" 
  # "../triangle/x100y100.db" 
  # "../triangle/x200y200.db" 
  # "../triangle/x400y400.db" 
    "../triangle/super7.db" 
  db_open is DBH_m
    "../triangle/super7_P002.db" 
  db_open is DBH_p
  DBH_m DBH_p 0 fea_assemble
  DBH_m db_close
  DBH_p db_close
  is Kgg
  is Mgg
time - -1 * " %.3f seconds to generate [Kgg], [Mgg] " format . nl

Kgg cols is Ng

Ng "G-size is %3.f dof " format . nl
Kgg spflip_sym is Kg
Mgg spflip_sym is Mg

# Kg Mg eig_check

Kg Mg  -1.0e5 12 speig_near_shift drop # ( eVal eVec )
swap "eigenvalues:" . nl .m nl
halt

INF "mtext" "ColsMax" bank
INF "mtext" "RowsMax" bank

"evec.07" dup deleteif "BIN" dup closeif new binary file
dup 7 catch
" % 22.16e " those cols cats format
textput
BIN fwrite (pos len) "len3" book (pos) drop
BIN close

"evec.08" dup deleteif "BIN" dup closeif new binary file
dup 8 catch
" % 22.16e " those cols cats format
textput
BIN fwrite (pos len) "len3" book (pos) drop
BIN close

"evec.09" dup deleteif "BIN" dup closeif new binary file
dup 9 catch
" % 22.16e " those cols cats format
textput
BIN fwrite (pos len) "len3" book (pos) drop
BIN close

"evec.10" dup deleteif "BIN" dup closeif new binary file
dup 10 catch
" % 22.16e " those cols cats format
textput
BIN fwrite (pos len) "len3" book (pos) drop
BIN close

"evec.11" dup deleteif "BIN" dup closeif new binary file
dup 11 catch
" % 22.16e " those cols cats format
textput
BIN fwrite (pos len) "len3" book (pos) drop
BIN close

"evec.12" dup deleteif "BIN" dup closeif new binary file
dup 12 catch
" % 22.16e " those cols cats format
textput
BIN fwrite (pos len) "len3" book (pos) drop
BIN close

# 8 catch write_modeshape # .m nl  # print the specified mode shape

halt
# 
# list: 7 Ng thru ; is g2x_part_vec
# 
# Kgg g2x_part_vec g2x_part_vec submat is Kxx
# Kxx spflip_sym is Kxx_full
# Kxx cols is Nx
# 1 Nx 1 fill is RHS
# 
# Kxx_full spinfo
# Nx speye is M
# 
# Kxx_full M 10  8 speig_near_shift drop ( Evec Eval )
# is eVec
# is eVal
# "sparse eigenvalues = " . nl eVal .m nl
# "max eigenvalue error: " . nl
# Kxx_full eVec * M eVec * eVal diagpost - abs maxfetch drop drop .m nl
# 
# halt
# Kxx_full dense Nx Nx null complex
# M        dense Nx Nx null complex zggev
# drop drop
# /by
# .m nl

list: 2 4 ; is g2x_part_vec # renumbered ID's of nodes to fully constrain
list: 1   ; is g2x_part_vec # renumbered ID's of nodes to fully constrain
Kgg g2x_part_vec constrain_nodes is Kxx
Kxx spflip_sym is Kxx_full
Kxx cols is Nx
1 Nx 1 fill is RHS

time 
  Kxx_full splu drop RHS spfbs is X  ( Kxx_full LU)
                               is LU ( Kxx_full )
  drop
time - -1 * " %.3f seconds to solve [Kxx][X] = [RHS] w/splu" format . nl

Kxx X spmult_sym_low_sd_rr is RHS_comp
RHS RHS_comp - 
"error for size " . Nx "%3.0f " format . " = " .
abs maxfetch drop drop . nl

halt

spinfo

dense
dup bend 1 triu +
dgeev          ( Kgg --- hLr hLi hAr hAi )
drop drop drop ( hLr hLi hAr hAi --- hLr )
.m
