\ {{{1 GNU General Public License
{
Program Tops - a stack-based computing environment
Copyright (C) 1999-2005  Dale R. Williamson

Author: Dale R. Williamson <dale.williamson@prodigy.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
1}}} 
}
{  File sys/ukey.v 

   User additional words at boot time.

   When this file is present, it will be sourced during start up for 
   an interactive session.

   This file is a place to source files or define words that you want 
   loaded each time an interactive session begins.

   Words defined and files sourced for either batch or interactive 
   processing can instead be placed in file uboot.v, which is always 
   loaded before this one.

   File usr/ukey.v is probably sourcing this file, sys/ukey.v.
}
   "keyboard" missing IF halt THEN

   ukey_done 
   IF " ukey.v: only at start up" . nl halt THEN \ only source once

\-----------------------------------------------------------------------
{
\  This banks yes for the INFIX flag that psource has just saved, over-
\  riding whatever is there.  Now during start up in keyboard mode the
\  progarm will switch to infix mode and the infix prompt will appear.
\  Place these lines in usr/ukey.v for this behavior:
   yes "psource" "buf" yank (hA)
   "psource" "count" yank 1st max ndx (f hA n) poke
}
\-----------------------------------------------------------------------

\  Editor words using system word eview (which uses word edit for a 
\  graphical editor):

   inline: iview (hA --- ) \ view matrix A as rounded integers
      depth 0= IF return THEN
      (hA) this named swap (qName hA)
      this is_sparse IF dense THEN
      no MAT stkok not IF (qName hA) lop eview return THEN
      rounded (qName hA) swap naming       
      mformat push       \ save format
      "%8.0f" mformatset
      fview
      pull mformatset    \ restore format
   end

   inline: rview (hA --- ) \ view matrix A of reals in editor, mformat
      eview ;

\  Ensure at least 128 columns for word mtext, used by word .m:
      128 "mtext" "ColsMax" yank max (N)
      (N) "mtext" "ColsMax" bank \ max columns in mtext (file boot.v)

\  Maximum lines in history buffer (program sets only 50 on start up)
      1000 HLMAX \ max lines in history buffer

   private halt

\-----------------------------------------------------------------------

 \ Appendix

{  Sat Mar 20 09:46:36 PDT 2010

   Make a utility that gives key numbers associated with key-pressed
   events.  Use window control block wcb1 and event control block ecb1
   that are created in xterm.v for the example in man wincreate.

   To run this utility, copy the following phrase at the ready prompt:

      syspath "ukey.v" + "KEYMAP" msource

   Then move the mouse arrow into graphics window "My Window" to give
   it focus and start pressing keys to see output after the ready
   prompt in the text window.

   When held down long enough, most keys return a released key code
   even when not released, then immediately return another pressed
   key code.

   Unlike most other keys, Shift, Ctrl, Alt and that funny Windows key
   located between Ctrl and Alt do not continue to return pressed key
   codes (do not run away) as they continue to be held down.

   KEYMAP "plot.v" source

   inline: KP1 (hEV hW --- ) \ handler for key pressed event
      KP \ running pressed key handler in plot.v
      " KP: pressed key code:" .  "KP" "NKEY" yank .i nl
   end

   inline: KR1 (hEV hW --- ) \ handler for key released event
      KR \ running released key handler in plot.v
      " KR: released key code:" .  "KR" "NKEY" yank .i nl
   end
{
   See xterm.v for the set up of wcb1 and ecb1 for the "My Window" demo
   of man wincreate.

   When window control block wcb1 was created, an event control block
   called ecb1 was created for it.

   Override the default event control handlers for key-pressed and key-
   released events with KP1 and KR1 created above:
}
   "KP1" ptr ecb1 ecb.kp poke \ KeyPressedEvent handler
   "KR1" ptr ecb1 ecb.kr poke \ KeyReleasedEvent handler

 \ This shows the window:
   wcb1 "My Window" wincreate wcb1 winshow

   halt \ KEYMAP demo
}
